/*
 * Admin mod script. 
 * Originaly plugin_base Copyright (C) 2000, Alfred Reynolds.
 * $          Modified by Caveman 00:24 10/12/2001                   $
 * $    If it works, blame Alfred, if it dont, blame Cavey ;)        $
 *
*/

/* This is a replacement for admin_vote_map that includes the ability
   to cancel the map vote. */

#include <core>
#include <console>
#include <string>
#include <admin>
#include <adminlib>

/*Chenge this to define the level of admins able to cancle the vote*/
#define ACCESS_CANCELMAPVOTE 64

new STRING_VERSION[MAX_DATA_LENGTH] = "2.50.2";

/* When changing maps with admin_map or by a vote, the mp_timelimit
 * gets set to 1 to trigger the scoreboard before the change.
 * If you have the problems with admin_map changing to the next map
 * in the map cycle instead of the map specified set the value in
 * PRECHANGE_TIMELIMIT to 2 and recompile the plugin. 
 */
new PRECHANGE_TIMELIMIT[] = "mp_timelimit 1";
new flag;

public admin_vote_map(HLCommand,HLData,HLUserName,UserIndex) {
	new Command[MAX_COMMAND_LENGTH];
	new Data[MAX_DATA_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new User[MAX_NAME_LENGTH];

	if (vote_allowed()!=1) {
		selfmessage( "Vote not allowed at this time.");
		return PLUGIN_HANDLED;
	}
	flag=0;	
	convert_string(HLCommand,Command,MAX_COMMAND_LENGTH);
	convert_string(HLData,Data,MAX_DATA_LENGTH);
	convert_string(HLUserName,User,MAX_NAME_LENGTH);
	if (valid_map(Data) == 1) {
		snprintf(Text, MAX_TEXT_LENGTH, "Change map to %s?", Data);
		log(Text);
		vote(Text,"Yes","No","HandleMapVote",Data);
	} else {
		selfmessage("Bad map name");
		selfmessage(Data);
	}
	return PLUGIN_HANDLED;
}

/* Handle a map vote's results. */
public HandleMapVote(WinningOption,HLMap,VoteCount,UserCount) {
	new strNumber[MAX_NUMBER_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new VoteMap[MAX_DATA_LENGTH];
	convert_string(HLMap,VoteMap,MAX_DATA_LENGTH);
	new sTimelimit[10];
	getstrvar("mp_timelimit", sTimelimit, 10);
		
	if (flag==0){
		if (WinningOption == 1) {
			new Ratio = getvar("map_ratio");
			if (VoteCount >= Ratio*UserCount/100) {
				snprintf(Text, MAX_TEXT_LENGTH, "Changing map to %s due to vote.", VoteMap);
				say(Text);
				exec(PRECHANGE_TIMELIMIT);
				set_serverinfo( "config_mp_timelimit", sTimelimit );
				set_timer("ChangeMap",2,1,VoteMap);
			} else {
				numtostr(Ratio*UserCount/100,strNumber);
				snprintf(Text, MAX_TEXT_LENGTH, "Map vote succeeded, but not enough votes for change (needed %s)", strNumber);
				say(Text);
			}
		} else {
			say("Map vote failed.");
		}
	} else {
		snprintf(Text, MAX_TEXT_LENGTH, "Map vote canceled by admin");
		flag=0;
		say(Text);
	}
}

public admin_cancelmapvote(HLCommand,HLData,HLUserName,UserIndex) {
	new Text[MAX_TEXT_LENGTH];

	flag=1;	
	snprintf(Text, MAX_TEXT_LENGTH, "Admin attempting to cancel map vote");
	say(Text);
	return PLUGIN_HANDLED;
}

public plugin_init() {
	plugin_registerinfo("Map vote enhancment","Basic Admin Mod commands.",STRING_VERSION);
	
	plugin_registercmd("admin_vote_map","admin_vote_map",ACCESS_ALL,"admin_vote_kick <target>: Starts a vote to kick target.");
	plugin_registercmd("admin_cancelmapvote","admin_cancelmapvote",ACCESS_CANCELMAPVOTE,"admin_vote_kick <target>: Starts a vote to kick target.");
	
	new strMap[MAX_DATA_LENGTH];
	new ExecCommand[MAX_DATA_LENGTH];
	new sStoredTimelimit [10];		

	get_serverinfo ("config_mp_timelimit", sStoredTimelimit, 10);
	if (strlen(sStoredTimelimit ) > 0) {
	  snprintf(ExecCommand, MAX_DATA_LENGTH, "mp_timelimit %s", sStoredTimelimit);
	  exec (ExecCommand);
	  set_serverinfo ("config_mp_timelimit", "");
	}

	currentmap(strMap, MAX_DATA_LENGTH);
	snprintf(ExecCommand, MAX_DATA_LENGTH, "%s.cfg", strMap);
	if ( fileexists(ExecCommand) ) {
	  snprintf(ExecCommand, MAX_DATA_LENGTH, "exec %s.cfg", strMap);
	  log(ExecCommand);
	  exec(ExecCommand);
	}
	
	return PLUGIN_CONTINUE;
}
